<?php

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class NC_Setup {

	public static $newscodes;

	public static function install() {

	}

	public static function init() {

		self::$newscodes['hovers'] = apply_filters( 'nc_supported_hovers', array(
			'fade' => esc_html__( 'Fade', 'nwscds' ),
			'slide-up' => esc_html__( 'Slide Up', 'nwscds' ),
			'slide-down' => esc_html__( 'Slide Down', 'nwscds' ),
			'slide-left' => esc_html__( 'Slide Left', 'nwscds' ),
			'slide-right' => esc_html__( 'Slide Right', 'nwscds' ),
			'reveal-up' => esc_html__( 'Reveal Up', 'nwscds' ),
			'reveal-down' => esc_html__( 'Reveal Down', 'nwscds' ),
			'reveal-left' => esc_html__( 'Reveal Left', 'nwscds' ),
			'reveal-right' => esc_html__( 'Reveal Right', 'nwscds' ),
			'hinge-up' => esc_html__( 'Hinge Up', 'nwscds' ),
			'hinge-down' => esc_html__( 'Hinge Down', 'nwscds' ),
			'hinge-left' => esc_html__( 'Hinge Left', 'nwscds' ),
			'hinge-right' => esc_html__( 'Hinge Right', 'nwscds' ),
			'flip-horiz' => esc_html__( 'Flip Horizontal', 'nwscds' ),
			'flip-vert' => esc_html__( 'Flip Vertical', 'nwscds' ),
			'flip-diag-1' => esc_html__( 'Flip Diagonal', 'nwscds' ) . ' 1',
			'flip-diag-2' => esc_html__( 'Flip Diagonal', 'nwscds' ) . ' 2',
			'shutter-out-horiz' => esc_html__( 'Shutter Out Horizontal', 'nwscds' ),
			'shutter-out-vert' => esc_html__( 'Shutter Out Vertical', 'nwscds' ),
			'shutter-out-diag-1' => esc_html__( 'Shutter Out Diagonal', 'nwscds' ) . ' 1',
			'shutter-out-diag-2' => esc_html__( 'Shutter Out Diagonal', 'nwscds' ) . ' 2',
			'shutter-in-out-horiz' => esc_html__( 'Shutter In Horizontal', 'nwscds' ),
			'shutter-in-out-vert' => esc_html__( 'Shutter In Vertical', 'nwscds' ),
			'shutter-in-out-diag-1' => esc_html__( 'Shutter In Diagonal', 'nwscds' ) . ' 1',
			'shutter-in-out-diag-2' => esc_html__( 'Shutter In Diagonal', 'nwscds' ) . ' 2',
			'fold-up' => esc_html__( 'Fold Up', 'nwscds' ),
			'fold-down' => esc_html__( 'Fold Down', 'nwscds' ),
			'zoom-in' => esc_html__( 'Zoom In', 'nwscds' )
		) );

		self::$newscodes['types'] = apply_filters( 'nc_supported_types', array(
			'news-poster' => esc_html__( 'Featured Poster', 'nwscds' ),
			'news-grid' => esc_html__( 'Grid', 'nwscds' ),
			'news-columned-featured-list' => esc_html__( 'Columned Featured List', 'nwscds' ),
			'news-columned-featured-list-tiny' => esc_html__( 'Columned Featured List Tiny', 'nwscds' ),
			'news-columned-featured-list-compact' => esc_html__( 'Columned Featured List Compact', 'nwscds' ),
			'news-list' => esc_html__( 'List', 'nwscds' ),
			'news-list-featured' => esc_html__( 'List with Featured', 'nwscds' ),
			'news-list-compact' => esc_html__( 'List Compact', 'nwscds' ),
			'news-list-compact-featured' => esc_html__( 'List Compact with Featured', 'nwscds' ),
			'news-list-tiny' => esc_html__( 'List Tiny', 'nwscds' ),
			'news-list-tiny-featured' => esc_html__( 'List Tiny with Featured', 'nwscds' ),
			'news-marquee' => esc_html__( 'Marquee', 'nwscds' ),
			'news-ticker' => esc_html__( 'Ticker', 'nwscds' ),
			'news-ticker-compact' => esc_html__( 'Ticker Compact', 'nwscds' ),
			'news-ticker-tiny' => esc_html__( 'Ticker Tiny', 'nwscds' ),
			'news-one-tabbed-posts' => esc_html__( 'One Tabbed Posts', 'nwscds' ),
			'news-grid-author' => esc_html__( 'Grid Author', 'nwscds' ),
			'news-list-author-featured' => esc_html__( 'List with Featured Author', 'nwscds' ),
			'news-list-author-compact-featured' => esc_html__( 'List Compact with Featured Author', 'nwscds' ),
			'news-list-author-tiny-featured' => esc_html__( 'List Tiny with Featured Author', 'nwscds' ),
		) );

		self::$newscodes['atts'] = array(
			'type' => 'news-list-compact',
			'style' => '',
			'style_cs' => '',
			'ajax' => 'true',
			'columns' => 3,
			'post_type' => 'post',
			'post_status' => 'publish',
			'posts_per_page' => 10,
			'posts_per_column' => 3,
			'offset' => '',
			'orderby' => 'date',
			'order' => 'DESC',
			'excerpt_length' => 20,
			'excerpt_more' => '',
			'image_ratio' => '4-3',
			'image_size' => '',
			'pagination' => 'true',
			'load_more' => 'false',
			'show_date' => 'true',
			'show_time' => 'true',
			'show_taxonomy' => 'true',
			'which_taxonomy' => '',
			'show_author' => 'true',
			'show_format' => 'true',
			'title_cut' => 'false',
			'title_tag' => 'h2',
			'filters' => '',
			'filter_terms' => '',
			'filter_relation' => 'OR',
			'meta_keys' => '',
			'meta_values' => '',
			'meta_compares' => '',
			'meta_types' => '',
			'meta_relation' => 'OR',
			'post_in' => '',
			'post_notin' => '',
			'marquee_direction' => 'left',
			'ticker_visible' => 3,
			'ticker_direction' => 'up',
			'section_title' => esc_html__( 'Title', 'nwscds' ),
			'http_query' => '',
			'poster_image' => '',
			'ajax_return' => '',
			'unique_id' => '',
			'hover' => ''
		);

		self::$newscodes['atts_multi'] = array(
			'type' => 'news-list-compact',
			'style' => '',
			'style_cs' => ''
		);

	}

}

NC_Setup::init();

?>